﻿/*
NAME: dXML
VERSION: 0.3 - BETA
ACTIONSCRIPT: 3.0
BY: Donovan Hubbard, http://donovanh.com
DESCRIPTION: A class the creats an XML supper object that uses methoods of XML and XMLList.
Designed to allow for easier transversing of XML files.

Some of the tools in this class
	*dXML = creats a dXML object which is a combonation of the XMLList and XMLNode classes
			accepts a string that represents the path to the .xml document.
	*onLoaded = stores a function to be executed when the .xml document is loaded. 
	*showXdoc = returns a string the represents the entire xml document.
	*nodeBody = returns the value between the name specified nodes as a String
				accepts a string and returns a string.
	*getBodyAt = returns the value between the targeted nodes as a String
				accepts an arr an unlimeted amount of intergers that represent the targeted nodes location. for example:
				a value of (0,2,8) would return the contents of the eigth child of the second child of the first node in 
				the document.
	*getListAt = returns the entire targeted node as an XMLNode object
				accepts an arr an unlimeted amount of intergers that represent the targeted nodes location. for example:
				a value of (0,2,8) would return the node that is the eigth child of the second child of the first node in 
				the document. this comand is commonly used as a precursor to getAttribute.
	*getAttribute = returns the value of a specified attribuet on a specified node.
				accepts an XMLNode and a String with the name of the attribute (XMLNode, "link") would return the value 
				of the "link" attribute. it is suggested to use getListAt to target a specific XMLNode.
	
UPDATES:
as of BETA 0.3
	* REMOVED: getNodeFamily method has been removed. the reason for this is that there is now theXML:XML is a public var
		and all this method did was access the desendance property of theXML.
	* CHANGED: thsXML:XML var is now a public var so all of the properties and methods of the XML class are accessable.
	* CHANGED: getNumberOfNodes name has been changed to numberOfNodes, and is now a get function.
	* ADDED: ioError function to catch loading errors of the xml file.
	* ADDED: onLoadedError allows you to assign a function to be called incase the xml does not load.
	* ADDED: hinting var, when passed on instantiation as true, extra error reports and diagnostics will trace to output.
*/
package Utils
{
	import flash.xml.*;
	import flash.net.*;
	import flash.events.*;
	import flash.utils.*;
	import flash.errors.*;
	//
	public class dXML
	{
		private var xURL:URLRequest;
		private var xLoad:URLLoader;
		private var xDoc:XMLDocument = new XMLDocument;
		//
		//public properties of the dXML object
		public var theXML:XML;
		public var file_path:String = "";
		public var xml_folder:String = "";
		public static var hinting:Boolean = false;
		public var onLoaded:Function = null;
		public var onLoadedError:Function = null;
		//
		/************************************************************************
		* INIT, TRACE, AND OUTPUT METHODS
		************************************************************************/
		public function dXML(path:String="", folder:String="", hint=false, on_load:Function=null, load_error:Function=null)
		{
			file_path = path;
			xml_folder = folder;
			hinting = hint;
			onLoaded = on_load;
			onLoadedError = load_error;
			if (path!="")
			{
				xURL = new URLRequest(xml_folder+path);
				xLoad = new URLLoader(xURL);
				var dxObj:Object = new Object();
				xLoad.addEventListener(IOErrorEvent.IO_ERROR, ioError);
				xLoad.addEventListener("complete", buildXML);
			}else{
				htrace("no document was specified on initiation of dXML");
			}
		}
		public function showXdoc():String
		{
			return String(xDoc);
		}
		//PRIVATE FUNCTIONS
		private static function dtrace(t:*)
		{
			trace("dXML: "+t);
		}
		private static function htrace(t:*)
		{
			if(hinting==true)
				dtrace("Notice: "+t);
		}
		private static function etrace(t:*)
		{
			dtrace("ERROR!: "+t);
		}
		private function ioError(ioe:IOErrorEvent)
		{
			etrace("The following ioError ocurred on loading :: "+ioe+" :: Make sure your file is in the right place or you have spelled the path correctly.");
			if(onLoadedError!=null)
				onLoadedError();
		}
		/************************************************************************
		* PARSE, SPLICE, EDIT, AND DELETE METHODS
		************************************************************************/
		public function deleteNodeAt(...locs)
		{
			try{
				getListAt(locs).removeNode();
				updateXML();
			}catch(e:Error){
				etrace("The following error ocurred durning the deleteNodeAt action :: "+e);
			}
		}
		public function stringToXnode(s:String):XML
		{
			trace("stringToXnode :: "+s);
			var x_node:XML = new XML(Object(s));
			trace(x_node);
			return x_node;
		}
		//PRIVATE FUNCTIONS
		private function buildXML(e:Event)
		{
			try{
				var targ:Object = e.target;
				theXML = XML(targ.data);
				xDoc.ignoreWhite=true;
				xDoc.parseXML(theXML);
				if(onLoaded!=null)
					onLoaded();
			}catch(e:Error){
				etrace("The following error ocurred when attempting to parse your xml file :: "+e);
			}
		}
		private function updateXML()
		{
			theXML = XML(showXdoc());
		}		
		/************************************************************************
		* SEARCH FUNCTIONS
		************************************************************************/
		public function allNodesWithName(n:String, strip_tags:Boolean=false, asXMLnodes:Boolean=false):Array
		{
			var nodes:Array = new Array();
			var s_node:String = "<"+n+">";
			var e_node:String = "</"+n+">";
			var doc_scrap:String = String(theXML);
			var doc_length:int = doc_scrap.length;
			var doc_po:int = doc_scrap.indexOf(s_node)==-1?doc_po=doc_length:doc_po=0;
			var s_po:int = 0;
			var e_po:int = 0;
			while(doc_po<doc_length)
			{
				doc_scrap = String(theXML);
				doc_scrap = doc_scrap.substring(doc_po);
				s_po = doc_scrap.indexOf(s_node);
				if(s_po==-1)
				{	
					doc_po=doc_length;
					break;
				}
				var scrap2 = doc_scrap.substring(s_po);
				e_po = scrap2.indexOf(e_node);
				var new_node = doc_scrap.substring(s_po, s_po+e_po+e_node.length);
				doc_po += s_po+e_po+e_node.length
				if(strip_tags==true)
					new_node = new_node.substring(s_node.length, new_node.length-e_node.length);
				if(asXMLnodes==true)
				{
					/* NEED TO WORK ON THIS ONE */
					var new_xnode:XML = stringToXnode(new_node);
					nodes.push(new_xnode);
				}else{
					nodes.push(new_node);
				}
			}
			if(nodes.length==0)
				htrace("allNodesWithName: There were no nodes found containing the given name.");
			return nodes;
		}
		public function allNodesThatContain(s:String):Array
		{
			var nodes:Array = new Array();
			//this will return an array of nodes that have the desired string in them
			return nodes;
		}
		public function get numberOfNodes():Number
		{
			var xKidz:Number = theXML.descendants("*").length();
			return xKidz;
		}
		public function getListAt(...locs):XMLNode
		{
			var list:XMLNode = xDoc.firstChild;
			try{
				for (var a:int; a<locs.length; a++)
					list = list.childNodes[locs[a]];
			}catch(e:Error){
				htrace("getListAt: there is no node located at the given location["+locs+"]. :: "+e);
			}
			return list;
		}
		public function getBodyAt(...locs):String
		{
			var bod_val:String = null;
			try{
				var list:XMLNode = xDoc.firstChild;
				for(var a:int; a<locs.length; a++)
					list = list.childNodes[locs[a]];
				//trace("list = "+list+"\n\n");
				var str1:String = String(list);
				var split1:Array = str1.split(">");
				var str2:String = split1[1];
				var split2:Array = str2.split("<");
				bod_val = split2[0];
			}catch(e:Error){
				htrace("getBodyAt: there is no node located at the given location["+locs+"]. :: "+e);
			}
			return bod_val;
		}
		public function getAttribute(node:Object, att:String):Object
		{
			var attz:Object = node.attributes;
			var atVal:Object = null;
			for (var a in attz)
				if (String(a)==att)
					atVal = attz[a];
			if(atVal==null)
				htrace("getAttribute: the specified node "+node+" does not contain the attribute "+att+".");
			return atVal;
		}
		public function cycleThroughXML(funk:Function = null, x_list:* = null)
		{
			if(x_list==null)
				x_list = theXML.descendants("*");
			//trace("el = "+theXML.elements("*"));
			//trace("$$$$\n "+x_list.normalize()+" \n$$$$");
			//trace("kidz :: "+x_list.children());
			//trace("???  "+x_list.processingInstructions("Deep"));
			//trace(" ------- "+getBodyAt(0,1,0));
			for(var a in x_list)
			{
				//funk("\n\n *** "+x_list[a].child(0));
				//cycleThroughXML(funk, x_list[a].children());
				//funk("\n\n**** "+x_list[a].descendants("*"));
			//	trace(x_list[a]);
			}
		}
	}
}